/*
  sleep.h - Sleep Library

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#pragma once

#ifdef __linux__
  #include <time.h>
#else
  #include <windows.h>
#endif

class Sleep
{
  public:

    static void
    sleep(unsigned long ms)
    {
#ifdef __linux__
      struct timespec req;
      req.tv_sec  = (ms / 1000);
      req.tv_nsec = (ms % 1000) * 1000000;
      nanosleep(&req, NULL);
#else
      ::Sleep(ms);
#endif
    }
};
